// credguic.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "credguic.h"
#include "credguicDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCredguicApp

BEGIN_MESSAGE_MAP(CCredguicApp, CWinApp)
	//{{AFX_MSG_MAP(CCredguicApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCredguicApp construction

CCredguicApp::CCredguicApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCredguicApp object

CCredguicApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CCredguicApp initialization

BOOL CCredguicApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CCredguicDlg dlg;
	m_pMainWnd = &dlg;

//////// Begin insertion ///////////
	// tell where we are done
	TRACE("About to allocate an ECI object");

	// Allocate an ECI object
	pECI = new fixCclECI;

	// tell where we are
	TRACE("ECI object allocated");

//////// End insertion /////////////

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

//////// Begin insertion ///////////
	// Clean up memory by deleting the ECI object
	delete pECI;
//////// End insertion /////////////

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

//////// Begin insertion ///////////

////////////////////////////////////////////////////////////////
// Routine to get the value of a variable (CString) and then  
//  copy it into the CICS commarea.                           
////////////////////////////////////////////////////////////////

void CCredguicApp::move_comm(CString& VarData,
							 char   *CommField,
							 int    maxLen,
							 int    isNumber)

{
    int     len;
    LPTSTR  userdata;

    // Get the length of the CString data 
    len = VarData.GetLength();

    // Get a pointer to the CString data 
    userdata = VarData.GetBuffer(0);

    if (len > maxLen)
     {
       len = maxLen;
     }

    // set the field to blanks or zeros 
    if (isNumber == NUMERIC_FIELD)
    {
       // numeric field - initialize to zeros 
       memset(CommField,'0',maxLen);

       // copy the data, if there is any, right justified 
       if (len > 0)
       {
          memcpy(CommField + maxLen - len, userdata, len);
       }
    }
    else
    {
       // alpha field - initialize to blanks 
       if (isNumber == ALPHA_FIELD)
       {
          memset(CommField,' ',maxLen);
       }
       else
       {
          memset(CommField,'\0',maxLen);
       }

       // copy the data, if there is any, left justified 
       if (len > 0)
       {
          memcpy(CommField, userdata, len);
       }
    }

    // Release the buffer pointer 
    VarData.ReleaseBuffer();
}

////////////////////////////////////////////////////////////////
// Routine to move data into a BMS map type of field in the
// CICS COMMAREA.  This routine uses the move_comm routine
// above to move the data into the CICS COMMAREA, and then
// sets the BMS length field to the length of the input
// data.  This length is also added to a total length field
// that is passed in as the MAPlen parameter.
////////////////////////////////////////////////////////////////

void CCredguicApp::moveBMSfield(CString&  Vardata,    // Variable data from GUI
								char      *BMSfield,  // BMS Map Data Area
								short     *BMSlen,    // BMS Map Length field
								short     *MAPlen,    // Total Map Data length
								int       maxLen,     // Length of Data Area
								int       isNumber)   // Data Type

{
   int    len;

   move_comm(Vardata, BMSfield, maxLen, isNumber);

   // get the length of the new data 
   len = Vardata.GetLength();

   // make sure it is not too long 
   if (len > maxLen)
   {
      len = maxLen;
   }

   // set the BMS map length field 
   *BMSlen = len;

   // set the total BMS bytes in map field                   
   *MAPlen += len;
}

////////////////////////////////////////////////////////////////
// Routine to take data out of the CICS commarea and turn     
//  it into a valid CString, stripping trailing blanks.       
////////////////////////////////////////////////////////////////

void CCredguicApp::comm_move(CString& VarData, char *commarea, long Varlen)

{
   int  len;
   char temp[4096];

   // Erase the current contents of the CString variable 
   VarData.Empty();

   // Make sure we don't overflow our work variable 
   len = Varlen;
   if (len > 4096)
   {
      len = 4096;
   } // endif 

   // Get the data into a work variable 
   memcpy(temp, commarea, Varlen);
   temp[len] = 0;

   // strip trailing blanks 
   len--;
   while (temp[len] == ' ')
    {
      temp[len] = '\0';
      len--;

      if (len < 0)
         break;
    } // endwhile 

   VarData = temp;
}

////////////////////////////////////////////////////////////////
// Routine to save an integer as a number string              
////////////////////////////////////////////////////////////////

void CCredguicApp::int2char(const int i, char *result, const int len)

{
   char temp[18];
   int maxlen;

   itoa(i, temp, 10);

   if (len < 12)
   {
      maxlen = len;
   }
   else
   {
      maxlen = 11;
   } // endif 

   if (maxlen > 0)
   {
      memset(result, '0', maxlen);
      if (strlen(temp) > 0)
      {
         memcpy(result + maxlen - strlen(temp), temp, strlen(temp));
      } // endif 
   } // endif 
}

////////////////////////////////////////////////////////////////
// Routine to set a standard COMMAREA header fields
////////////////////////////////////////////////////////////////

void CCredguicApp::setStandardHeader(pCOMMHEAD ca, int calen, int maplen, 
									 char  *mapname, char *tranname)

{
	// Trace point for debugging
	TRACE("Entering setStandardHeader\n");

	// Get mapname and tranname into temporary CStrings
	CString map = mapname;
	CString tran = tranname;

	// set the version number to zero
	memset(ca->VERSION, '0',
			sizeof(ca->VERSION));

	// Set the Map Name field in the COMMAREA
	move_comm(map, ca->MAPNAME, 
							sizeof(ca->MAPNAME), ALPHA_FIELD);

	// Set the User Transaction Name field in the COMMAREA
	move_comm(tran, ca->USRTRNID, 
							sizeof(ca->USRTRNID), ALPHA_FIELD);

	// Set the Client Name field in the COMMAREA
	move_comm(cics_client_name, ca->USRTRMID, 
							sizeof(ca->USRTRMID), ALPHA_FIELD);

	// set the user commarea length 
	int2char(calen, ca->USRCALEN, sizeof(ca->USRCALEN));

	// set the BMS data length 
	int2char(maplen, ca->USRMAPLN,sizeof(ca->USRMAPLN));

	// Initialize the return code and next transaction id
	memset(ca->RETCODE, '0', sizeof(ca->RETCODE));
	memset(ca->NXTRNID, ' ', sizeof(ca->NXTRNID));

	// Set default aid byte to enter key
	ca->USRAID = '\x027';

	// Set default cursor position to 0,0
	memset(ca->USRCPOS, '0', sizeof(ca->USRCPOS));
}

////////////////////////////////////////////////////////////////
// Routine to dump the contents of the standard header in a 
//  CICS COMMAREA
////////////////////////////////////////////////////////////////

void CCredguicApp::dumpStandardHeader(pCOMMHEAD ca, CDumpContext& dc)

{
	// Work Variables
	CString vers;
	CString	map;
	CString mapset;
	CString clname;
	CString trans;
	CString calen;
	CString maplen;
	CString ret;
	CString nxtran;
	CString cpos;

	// Extract the data from the COMMAREA header
	comm_move(vers, ca->VERSION, sizeof(ca->VERSION));
	comm_move(map, ca->MAPNAME, sizeof(ca->MAPNAME));
	comm_move(mapset, ca->MAPSET, sizeof(ca->MAPSET));
	comm_move(clname, ca->USRTRMID, sizeof(ca->USRTRMID));
	comm_move(trans, ca->USRTRNID, sizeof(ca->USRTRNID));
	comm_move(calen, ca->USRCALEN, sizeof(ca->USRCALEN));
	comm_move(maplen, ca->USRMAPLN, sizeof(ca->USRMAPLN));
	comm_move(ret, ca->RETCODE, sizeof(ca->RETCODE));
	comm_move(nxtran, ca->NXTRNID, sizeof(ca->NXTRNID));
	comm_move(cpos, ca->USRCPOS, sizeof(ca->USRCPOS));

	// Dump the data
	dc << "VERSION      " << vers << "\n";
	dc << "MAP NAME     " << map << "\n";
	dc << "MAP SET      " << mapset << "\n";
	dc << "CLIENT NAME  " << clname << "\n";
	dc << "TRANS CODE   " << trans << "\n";
	dc << "COMMAREA LEN " << calen << "\n";
	dc << "MAP DATA LEN " << maplen << "\n";
	dc << "RETURN CODE  " << ret << "\n";
	dc << "NEXT TRANS   " << nxtran << "\n";
	dc << "CURSOR POS   " << cpos << "\n";
}

////////////////////////////////////////////////////////////////
// Routine to execute a CICS transaction
////////////////////////////////////////////////////////////////

int CCredguicApp::executeCICSTran(char* tran, int casize, void *dataArea)

{
	// Trace point for debugging
	TRACE("Entering executeCICSTran\n");

	// Make sure we don't have a null pointer
	ASSERT(dataArea != NULL);

	// Make sure the COMMAREA size is > 0
	ASSERT(casize > 0);

	int RC = Ccl::noError;

	// Set the Cursor to an hour glass
	BeginWaitCursor();

	// Build a connection object
	CclConn connection(cics_system, cics_user, cics_pw);

	// Build a buffer object
	CclBuf buffer(casize, dataArea);

	// Build a flow object
	CclFlow sflow(Ccl::sync);

	// Clear the previous CICS error message text
	cics_message.Empty();
	cics_abcode.Empty();

	try {	// Catch block for CclClass exceptions
		connection.link(sflow, tran, &buffer);
    }    // Catch CclClass exceptions
	catch ( CclException& exception ) 
	{
		// Trace point for debugging
		TRACE("CICS ECI error - %s\n",exception.exCodeText);

		AfxMessageBox(exception.exCodeText(), MB_OK);
		RC = exception.exCode();
		cics_message = exception.exCodeText();

		// Check for CICS Transaction abend error
		// Is it a CICS transaction abend?
		if ((Ccl::ExCode) exception.exCode() == Ccl::transaction)
		{
			cics_abcode = pECI->m_Cclabcode;

			// Trace point for debugging
			TRACE("CICS transaction abend - %s\n", cics_abcode);
		}
	} // end catch

	// Return to a normal cursor
	EndWaitCursor();

	return RC;
}

//////// End insertion /////////////
